<template>
  <main id="browse-content">
    <div class="title-block">
      <h1>
        <SafeHTML>
          {{ $gettext('<strong>Browse PeerTube content</strong> with SepiaSearch', true) }}
        </SafeHTML>
      </h1>

      <div class="small-separator"></div>

      <p class="explanation">
        {{ $gettext('You\'re looking for videos or channels? Ask Sepia, our iconic cuttlefish!') }}
      </p>
    </div>

    <div class="small-container color-container position-relative form-container">
      <button class="warning-button popover-button">
        <div class="visually-hidden">{{ $gettext('Toggle warning information') }}</div>

        <IconWarning></IconWarning>
      </button>

      <form class="mx-auto" onsubmit="return false;">

        <label class="mb-1" for="search">
          {{ $gettext('My search') }}
        </label>

        <div class="d-flex position-relative">
          <SepiaSearchImage class="sepia-mascot"></SepiaSearchImage>

          <input
            id="search"
            v-model="formSearch"
            class="grouped"
            :placeholder="getPlaceholder()" type="text" name="search" autofocus
            autocapitalize="off" autocomplete="off" autocorrect="off" maxlength="1024"
          />

          <button class="jpt-primary-button jpt-smaller-button text-nowrap" @click="doSearch()">
            {{ $gettext('Explore!') }}
          </button>
        </div>
      </form>

      <p class="mx-auto mt-4 text-center">
        <SafeHTML>
          {{ $gettext('Looking for <strong>PeerTube platforms</strong> instead?', true) }}
        </SafeHTML>

        <br />

        <router-link to="/instances" class="mx-auto jpt-router-link">
          <span>{{ $gettext('Go here') }}</span>
        </router-link>
      </p>
    </div>

    <div v-if="searchDone" id="results" ref="resultsEl" class="small-container result-container">
      <h2 v-if="getTotalResults() === 0">{{ $gettext('No results found') }}</h2>

      <h2 v-if="getTotalResults() !== 0">{{ $ngettext('%{total} result found', '%{total} results found', getTotalResults(), { total: getTotalResults() + '' }) }}</h2>

      <div>
        <h3>
          <strong>
            {{ $ngettext('%{totalVideos} video', '%{totalVideos} videos', totalVideos, { totalVideos: totalVideos + '' }) }}
          </strong>
        </h3>

        <template v-if="totalVideos">
          <div v-for="video in videos" :key="video.url" class="mb-4">
            <VideoResult :video="video"></VideoResult>
          </div>

          <div class="mb-5 text-center">
            <a
              class="jpt-link-button jpt-secondary-button jpt-smaller-button"
              target="_blank" rel="nofollow noreferrer noopener" :href="getMoreResultsLink('videos')"
            >
              {{ $gettext('Display more videos') }}
            </a>
          </div>
        </template>
      </div>

      <div>
        <h3>
          <strong>
            {{ $ngettext('%{totalChannels} channel', '%{totalChannels} channels', totalChannels, { totalChannels: totalChannels + '' }) }}
          </strong>
        </h3>

        <template v-if="totalChannels">
          <div v-for="channel in channels" :key="channel.url" class="mb-4">
            <ChannelResult :channel="channel"></ChannelResult>
          </div>

          <div class="mb-5 text-center">
            <a
              class="jpt-link-button jpt-secondary-button jpt-smaller-button"
              target="_blank" rel="nofollow noreferrer noopener" :href="getMoreResultsLink('channels')"
            >
              {{ $gettext('Display more channels') }}
            </a>
          </div>
        </template>
      </div>

      <div>
        <h3>
          <strong>
            {{ $ngettext('%{totalPlaylists} playlist', '%{totalPlaylists} playlists', totalPlaylists, { totalPlaylists: totalPlaylists + '' }) }}
          </strong>
        </h3>

        <template v-if="totalPlaylists">
          <div v-for="playlist in playlists" :key="playlist.url" class="mb-4">
            <PlaylistResult :playlist="playlist"></PlaylistResult>
          </div>

          <div class="mb-5 text-center">
            <a
              class="jpt-link-button jpt-secondary-button jpt-smaller-button"
              target="_blank" rel="nofollow noreferrer noopener" :href="getMoreResultsLink('playlists')"
            >
              {{ $gettext('Display more playlists') }}
            </a>
          </div>
        </template>
      </div>
    </div>
  </main>
</template>

<script>
  import { defineComponent } from 'vue'

  import { useGettext } from 'vue3-gettext'
  import { useHead } from '@vueuse/head'

  import SepiaSearchImage from '../components/SepiaSearchImage.vue'
  import IconWarning from '../components/icons/IconWarning.vue'

  import VideoResult from '../components/browse-content/VideoResult.vue'
  import ChannelResult from '../components/browse-content/ChannelResult.vue'
  import PlaylistResult from '../components/browse-content/PlaylistResult.vue'

  import { httpGet } from '../shared/http'
  import { buildHead } from '../shared/head'

  export default defineComponent({
    components: {
      SepiaSearchImage,
      IconWarning,

      VideoResult,
      ChannelResult,
      PlaylistResult
    },

    setup () {
      const { $gettext } = useGettext()

      return useHead(buildHead({
        title: $gettext('Browse PeerTube content'),
        url: import.meta.env.VITE_URL + '/browse-content',
        description: $gettext('Find PeerTube videos, channels and playlists by browsing PeerTube content using SepiaSearch!'),
        image: import.meta.env.VITE_URL + '/img/seo/search.jpg'
      }))
    },

    data () {
      return {
        searchIndexUrl: 'https://sepiasearch.org',
        formSearch: '',

        searchDone: false,

        totalVideos: undefined,
        videos: [],

        totalChannels: undefined,
        channels: [],

        totalPlaylists: undefined,
        playlists: []
      }
    },

    mounted () {
      // eslint-disable-next-line no-new
      import('bootstrap/js/dist/popover')
        .then(Popover => {
          new Popover.default(this.$el.querySelector('.popover-button'), {
            html: true,

            content: this.$gettext('Sepia does its best to display videos, channels and playlists matching your search, but its <strong>SepiaSearch tool is neither the publisher nor the owner of this content</strong>.') +
              '<br /><br />' +
              this.$gettext('If you see any problems with a video, <strong>report them to an administrator directly</strong> on the PeerTube platform where it is hosted.')
          })
        })

      this.doSearch()
    },

    methods: {
      getPlaceholder () {
        return this.$gettext('Example: music, cooking, big buck bunny, blender...')
      },

      getTotalResults () {
        return this.totalChannels + this.totalPlaylists + this.totalVideos
      },

      async doSearch () {
        if (!this.formSearch) return

        await Promise.all([
          this.searchVideos(),
          this.searchChannels(),
          this.searchPlaylists()
        ])

        this.searchDone = true

        setTimeout(() => {
          const el = this.$refs.resultsEl
          if (el) this.$refs.resultsEl.scrollIntoView()
        })
      },

      async searchVideos () {
        const params = { search: this.formSearch, count: 2 }

        try {
          const { total, data } = await httpGet(this.searchIndexUrl + '/api/v1/search/videos', params)
          this.totalVideos = total
          this.videos = data
        } catch (err) {
          console.error(err)

          this.totalVideos = 0
          this.videos = []
        }
      },

      async searchChannels () {
        const params = { search: this.formSearch, count: 2 }

        try {
          const { total, data } = await httpGet(this.searchIndexUrl + '/api/v1/search/video-channels', params)

          this.totalChannels = total
          this.channels = data
        } catch (err) {
          console.error(err)

          this.totalChannels = 0
          this.channels = []
        }
      },

      async searchPlaylists () {
        const params = { search: this.formSearch, count: 2 }

        try {
          const { total, data } = await httpGet(this.searchIndexUrl + '/api/v1/search/video-playlists', params)

          this.totalPlaylists = total
          this.playlists = data
        } catch (err) {
          console.err(err)

          this.totalPlaylists = 0
          this.playlists = []
        }
      },

      getMoreResultsLink (resultType) {
        return this.searchIndexUrl + '/search?search=' + this.formSearch + '&resultType=' + encodeURIComponent(resultType)
      }
    }
  })
</script>

<style lang="scss" scoped>
  @import '../scss/_variables.scss';
  @import '../scss/_mixins.scss';
  @import '../scss/bootstrap-mixins.scss';

  #browse-content {

    .warning-button {
      @include disable-default-button-behaviour;

      position: absolute;
      top: 5px;
      right: 5px;

      svg {
        width: 50px;
        height: 50px;
      }

      &:hover {
        opacity: 0.8;
      }
    }

    .sepia-mascot {
      max-width: 220px;
      margin-inline-start: auto;
      margin-inline-end: auto;
      position: absolute;
      bottom: 36px;
      left: 0;
      right: 0;
    }

    .form-container {
      margin-top: 150px;

      > * {
        max-width: 600px;
      }
    }

    .form-container {
      label {
        @include proza;
        @include font-size(1.125rem);

        display: block;
        font-weight: $font-bold;
      }

      input {
        width: 100%;
      }
    }

    .result-container {
      @include margin-top(4rem);

      h2 {
        font-family: inherit;
        font-size: 1rem;
        text-align: center;
        font-weight: $font-semibold;
        margin-bottom: 1rem;
      }

      h3 {
        @include font-size(1.125rem);
      }
    }

    @include media-breakpoint-down(md) {
      .form-container {
        padding-top: 3rem !important;
      }
    }

    @include media-breakpoint-down(sm) {
      .form-container {
        label {
          visibility: hidden;
        }
      }
    }
  }

</style>
